

# 组件堆栈

> 译者：[flink.sojb.cn](https://flink.sojb.cn/)


作为软件堆栈，Flink是一个分层系统。堆栈的不同层构建在彼此之上，并提高它们接受的程序表示的抽象级别：

*   在**运行时**层中的形式接收节目_JobGraph_。JobGraph是一个通用的并行数据流，具有消耗和生成数据流的任意任务。

*   二者**的数据流中的API**和**数据集API**生成通过单独的编译过程JobGraphs。DataSet API使用优化器来确定程序的最佳计划，而DataStream API使用流构建器。

*   JobGraph根据Flink中提供的各种部署选项执行（例如，本地，远程，YARN等）

*   与Flink捆绑在一起的库和API生成DataSet或DataStream API程序。这些是用于逻辑表的查询的表，用于机器学习的FlinkML和用于图形处理的Gelly。

您可以单击图中的组件以了解更多信息。

<center>![Apache Flink：Stack](../img/stack.png)</center>

<map name="overview-stack"><area id="lib-datastream-cep" title="CEP: Complex Event Processing" href="https://flink.sojb.cn/dev/libs/cep.html" shape="rect" coords="63,0,143,177"> <area id="lib-datastream-table" title="Table: Relational DataStreams" href="https://flink.sojb.cn/dev/table_api.html" shape="rect" coords="143,0,223,177"> <area id="lib-dataset-ml" title="FlinkML: Machine Learning" href="https://flink.sojb.cn/dev/libs/ml/index.html" shape="rect" coords="382,2,462,176"> <area id="lib-dataset-gelly" title="Gelly: Graph Processing" href="https://flink.sojb.cn/dev/libs/gelly/index.html" shape="rect" coords="461,0,541,177"> <area id="lib-dataset-table" title=" Table API and SQL" href="https://flink.sojb.cn/dev/table_api.html" shape="rect" coords="544,0,624,177"> <area id="datastream" title="DataStream API" href="https://flink.sojb.cn/dev/datastream_api.html" shape="rect" coords="64,177,379,255"> <area id="dataset" title="DataSet API" href="https://flink.sojb.cn/dev/batch/index.html" shape="rect" coords="382,177,697,255"> <area id="runtime" title="Runtime" href="https://flink.sojb.cn/concepts/runtime.html" shape="rect" coords="63,257,700,335"> <area id="local" title="Local" href="https://flink.sojb.cn/tutorials/local_setup.html" shape="rect" coords="62,337,275,414"> <area id="cluster" title="Cluster" href="https://flink.sojb.cn/ops/deployment/cluster_setup.html" shape="rect" coords="273,336,486,413"> <area id="cloud" title="Cloud" href="https://flink.sojb.cn/ops/deployment/gce_setup.html" shape="rect" coords="485,336,700,414"></map> 