

# 在Windows上运行Flink

> 译者：[flink.sojb.cn](https://flink.sojb.cn/)


如果要在Windows计算机上本地运行Flink，则需要[下载](http://flink.apache.org/downloads.html)并解压缩二进制Flink分发。之后，您可以使用**Windows批处理**文件（`.bat`），或使用**Cygwin**运行Flink JobManager。

## 从Windows批处理文件开始

要从_Windows命令行_启动Flink ，请打开命令窗口，导航到`bin/`Flink目录并运行`start-cluster.bat`。

注意：`bin`Java Runtime Environment 的文件夹必须包含在Window的`%PATH%`变量中。按照本[指南](http://www.java.com/en/download/help/path.xml)将Java添加到`%PATH%`变量中。



```
$ cd flink
$ cd bin
$ start-cluster.bat
Starting a local cluster with one JobManager process and one TaskManager process.
You can terminate the processes via CTRL-C in the spawned shell windows.
Web interface by default on http://localhost:8081/.
```



之后，您需要打开第二个终端来运行作业`flink.bat`。

## 从Cygwin和Unix Scripts开始

使用_Cygwin，_您需要启动Cygwin终端，导航到您的Flink目录并运行`start-cluster.sh`脚本：



```
$ cd flink
$ bin/start-cluster.sh
Starting cluster.
```



## 从Git安装Flink

如果您正在从git存储库安装Flink并且您正在使用Windows git shell，则Cygwin可能会产生类似于以下的故障：



```
c:/flink/bin/start-cluster.sh: line 30: /figure>\r': command not found
```



发生此错误是因为在Windows中运行时，git会自动将UNIX行结尾转换为Windows样式行结尾。问题是Cygwin只能处理UNIX样式的行结尾。解决方案是通过以下三个步骤调整Cygwin设置以处理正确的行结尾：

1.  启动一个Cygwin shell。

2.  输入确定您的主目录



```
 cd; pwd 
```



```
This will return a path under the Cygwin root path. 
```

1.  使用NotePad，写字板或其他文本编辑器打开`.bash_profile`主目录中的文件并附加以下内容:(如果文件不存在，则必须创建它）



```
export SHELLOPTS
set -o igncr
```



保存文件并打开一个新的bash shell。

