

# Apache Flink文档

> 译者：[flink.sojb.cn](https://flink.sojb.cn/)

本文档适用于Apache Flink 1.7-SNAPSHOT版。这些页面的建立时间为：09/08/18，中部标准时间07:53:00。

Apache Flink是一个用于分布式流和批处理数据处理的开源平台。Flink的核心是流数据流引擎，为数据流上的分布式计算提供数据分发，通信和容错。Flink在流引擎之上构建批处理，覆盖本机迭代支持，托管内存和程序优化。

## 第一步

*   **概念**：从Flink的[数据流编程模型](https://flink.sojb.cn/concepts/programming-model.html)和[分布式运行时环境](https://flink.sojb.cn/concepts/runtime.html)的基本概念开始。这将有助于您了解文档的其他部分，包括设置和编程指南。我们建议您先阅读这些部分。

*   **教程**：
    *   [实现并运行DataStream应用程序](https://flink.sojb.cn/tutorials/datastream_api.html)
    *   [设置本地Flink群集](https://flink.sojb.cn/tutorials/local_setup.html)
*   **编程指南**：您可以阅读我们关于[基本API概念](https://flink.sojb.cn/dev/api_concepts.html)和[DataStream API](https://flink.sojb.cn/dev/datastream_api.html)或[DataSet API的指南，](https://flink.sojb.cn/dev/batch/index.html)以了解如何编写您的第一个Flink程序。

## 部署

在将Flink工作投入生产之前，请阅读[生产准备清单](https://flink.sojb.cn/ops/production_ready.html)。

## 发行说明

发行说明涵盖了Flink版本之间的重要更改。如果您计划将Flink设置升级到更高版本，请仔细阅读这些说明。

*   [Flink 1.6发行说明](https://flink.sojb.cn/release-notes/flink-1.6.html)。
*   [Flink 1.5发行说明](https://flink.sojb.cn/release-notes/flink-1.5.html)。

## 外部资源

*   **Flink Forward**：[Flink Forward](http://flink-forward.org/)网站和[YouTube上](https://www.youtube.com/channel/UCY8_lgiZLZErZPF47a2hXMA)提供了以往会议的讲座。[使用Apache Flink进行强大的流处理](http://2016.flink-forward.org/kb_sessions/robust-stream-processing-with-apache-flink/)是一个很好的起点。

*   **培训**：数据工匠的[培训材料](http://training.data-artisans.com/)包括幻灯片，练习和示例解决方案。

*   **博客**：[Apache Flink](https://flink.apache.org/blog/)和[数据工匠](https://data-artisans.com/blog/)博客发布了有关Flink的频繁，深入的技术文章。

