

# Streaming Concepts

Flink’s [Table API](../tableApi.html) and [SQL support](../sql.html) are unified APIs for batch and stream processing. This means that Table API and SQL queries have the same semantics regardless whether their input is bounded batch input or unbounded stream input. Because the relational algebra and SQL were originally designed for batch processing, relational queries on unbounded streaming input are not as well understood as relational queries on bounded batch input.

The following pages explain concepts, practical limitations, and stream-specific configuration parameters of Flink’s relational APIs on streaming data.

## Where to go next?

*   [Dynamic Tables](//ci.apache.org/projects/flink/flink-docs-release-1.7/dev/table/streaming/dynamic_tables.html): Describes the concept of dynamic tables.
*   [Time attributes](//ci.apache.org/projects/flink/flink-docs-release-1.7/dev/table/streaming/time_attributes.html): Explains time attributes and how time attributes are handled in Table API & SQL.
*   [Joins in Continuous Queries](//ci.apache.org/projects/flink/flink-docs-release-1.7/dev/table/streaming/joins.html): Different supported types of Joins in Continuous Queries.
*   [Temporal Tables](//ci.apache.org/projects/flink/flink-docs-release-1.7/dev/table/streaming/temporal_tables.html): Describes the Temporal Table concept.
*   [Query configuration](//ci.apache.org/projects/flink/flink-docs-release-1.7/dev/table/streaming/query_configuration.html): Lists Table API & SQL specific configuration options.

